package org.nm.challenge.display;

import javax.swing.JSplitPane;

import org.jfree.ui.ApplicationFrame;
import org.nm.challenge.arrays.IArray2D;

public class CombinedDisplayFrame extends ApplicationFrame implements IDisplay {

	private static final long serialVersionUID = 1L;
	private final Display2DComponent display2d;
	private final JFreeChartDisplayPanel jfreeChart;

	public CombinedDisplayFrame() {
		super("display");
		display2d = new Display2DComponent();
		jfreeChart = new JFreeChartDisplayPanel();
		JSplitPane pane =  new JSplitPane(JSplitPane.VERTICAL_SPLIT, display2d, jfreeChart);
		setContentPane(pane);
	}

	public void update(final int iteration, final IArray2D mass) {
		display2d.update(iteration, mass);
		jfreeChart.update(iteration, mass);
	}

}
