package org.nm.challenge.wave;

import org.nm.challenge.arrays.Array2D;
import org.nm.challenge.arrays.IArray2D;

public class FullWaveProblemSetup implements IProblemSetup {

	private final Array2D H_0;
	private final Array2D U_0;
	private final Array2D V_0;
	
	private final Array2D H_1;
	private final Array2D U_1;
	private final Array2D V_1;
	
	private Array2D HNew;
	private Array2D UNew;
	private Array2D VNew;
	
	private Array2D H;
	private Array2D U;
	private Array2D V;
	
	private final int size_x;
	private final int size_y;
	private final boolean wavePhysics;
	
	public FullWaveProblemSetup(int size_y, int size_x, boolean wavePhysics) {
		this.size_x = size_x;
		this.size_y = size_y;
		this.wavePhysics = wavePhysics;
		
		H_0 = new Array2D(size_y+2, size_x+2);
		U_0 = new Array2D(size_y+2, size_x+2);
		V_0 = new Array2D(size_y+2, size_x+2);
		H_1 = new Array2D(size_y+2, size_x+2);
		U_1 = new Array2D(size_y+2, size_x+2);
		V_1 = new Array2D(size_y+2, size_x+2);
		HNew = H_0;
		H = H_1;
		UNew = U_0;
		U = U_1;
		VNew = V_0;
		V = V_1;
	}
	
	public Array2D getH() {
		return H;
	}

	public Array2D getU() {
		return U;
	}

	public Array2D getV() {
		return V;
	}

	public IArray2D getNewH() {
		return HNew;
	}

	public IArray2D getNewU() {
		return UNew;
	}

	public IArray2D getNewV() {
		return VNew;
	}

	public int getOffsetX() {
		return 0;
	}

	public int getOffsetY() {
		return 0;
	}

	public int getSizeX() {
		return size_x;
	}

	public int getSizeY() {
		return size_y;
	}

	public int getTotalSizeX() {
		return size_x;
	}

	public int getTotalSizeY() {
		return size_y;
	}

	public boolean isWavePhysics() {
		return wavePhysics;
	}

	public void swapArrays() {
		Array2D tmp;
		tmp = H;
		H = HNew;
		HNew = tmp;
		tmp = U;
		U = UNew;
		UNew = tmp;
		tmp = V;
		V = VNew;
		VNew = tmp;
	}
}
