#include <mpi.h>
#define MPE_GRAPHICS
#include "mpe.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include "wave.h"

int width=1000;
int height=400;//*/
/*int width=750;
int height=750;//*/
MPE_XGraph graph;
MPE_Color *color_array;
int ncolors=256;
char *label;
void display_init(char *displayname, int iwidth, int iheight){   

  int ierr;
  int rank;
  //int ncolors2;
  
 /* Open the graphics display */
 
 width=iwidth;
 height=iheight;
 
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPE_Open_graphics( &graph, MPI_COMM_WORLD, displayname, 
		   -1, -1, width, height+10, 0 );

  color_array = (MPE_Color *) malloc(sizeof(MPE_Color)*ncolors);
  
  ierr = MPE_Make_color_array(graph, ncolors, color_array);
  if (ierr && rank == 0) printf("Error(Make_color_array): ierr is %d\n",ierr);

  //MPE_Num_colors(graph, &ncolors2);
  //printf("size of color array is %d\n",ncolors2);
 
}
 
 void display_close(void){
   MPE_Close_graphics(&graph);
 }

void set_label(char *text)
{
	label=text;
}
void display_one_d(int matrix_size_x, int matrix_size_y, double **temp,
   int my_offset, int mysize, double maxscale)
{
  int i, j;
  unsigned int plot_value;
  /*double localmax=0;
  double localmin=2000;
  for(j=0;j<=mysize;j++){
    for(i=0;i<=matrix_size_x;i++){
      if(temp[j][i]>localmax)
        localmax=temp[j][i];
      if(temp[j][i]<localmin)
        localmin=temp[j][i];
    }
  }
  printf("localmax %f localmin %f\n", localmax, localmin);//*/
  for(j=1;j<=mysize;j++){
  	for(i=1;i<=matrix_size_x;i++){
	 int xloc, yloc, xwid, ywid;
	  xloc = ((i - 1) * width) / matrix_size_x;
	  yloc = ((my_offset + j - 1) * height/2) / matrix_size_y;
	  xwid = (i * width) / matrix_size_x - xloc;
	  ywid = ((my_offset + j) * height/2) / matrix_size_y - yloc;
	  plot_value = ncolors - ((double)ncolors*temp[j][i]/maxscale) + 2;
	  //printf("temp[%d][%d]=%lf\n",i,j,temp[j][i]);
	  if (plot_value < 2) plot_value = 2;
	  if (plot_value > ncolors) plot_value = ncolors;
	  //printf("%d %d %d %8.5f\n",i,j,plot_value,temp[i][j]);
	  if(isnan(temp[j][i]))MPE_Fill_rectangle( graph, xloc, yloc, xwid, ywid, MPE_WHITE);
	  else if(temp[j][i]<0)MPE_Fill_rectangle( graph, xloc, yloc, xwid, ywid, MPE_WHITE);
	  else if(temp[j][i]>maxscale)MPE_Fill_rectangle( graph, xloc, yloc, xwid, ywid, MPE_BLACK);
	  else MPE_Fill_rectangle(graph, xloc, yloc, xwid, ywid, color_array[plot_value]);
   }
  }//*/
  //if(debug==1){printf("Color display complete\n");}
  MPE_Fill_rectangle(graph, 0, height/2, width, height, MPE_WHITE);
  MPE_Fill_rectangle(graph, 0, height/2, width, 2, MPE_BLACK);
  for(i=1;i<=matrix_size_x;i++){
  	int xloc, xwid;
  	  xloc = ((i - 1) * width) / matrix_size_x;
  	  xwid = (i * width) / matrix_size_x - xloc;
  	  MPE_Fill_rectangle( graph, xloc, ((height)-(((height/2.1))*(temp[1][i]/maxscale))), xwid, 1, color_array[1]);
  }//*/
  //if(debug==1){printf("Graph display complete\n");}
  MPE_Fill_rectangle(graph, 0, height, width, height, MPE_WHITE);
  if(my_offset==0)MPE_Draw_string( graph, 0, height+10, MPE_BLACK, label);
  MPE_Update( graph );
  sleep(wait_time);
}
