#!/bin/sh

# this is just to get password at start
if test `uname` == "Darwin"; then
  sudo ls
fi
exit

# This installs Sun Java, OpenMPI and the MPE library

# May need to install Xcode Tools on Mac to get gcc and make
# installed.
 
# This may need to be run as root if the permissions on the 
# /usr/local directories are locked down.

# Edit the .bashrc file and add the following near the top
# vi ~/.bashrc

# export PATH=/usr/local/bin:$PATH (on Mac only)

# Now source your .bashrc file 
#    source ~/.bashrc


set -v

SRC_DIR=/home/dad/Desktop
if test `uname` == "Darwin"; then
  SRC_DIR=${HOME}/Desktop
fi
JDK_FILE=jdk-6u2-linux-i586.bin
JDK_DIR=jdk1.6.0_02
OPEN_MPI_VERSION=openmpi-1.2.3
MPICH_VERSION=mpich-1.2.7p1

if test -x /usr/local/sbin/mpeuninstall; then
  /usr/local/sbin/mpeuninstall
fi

if test `uname` == "Darwin"; then
  pushd /usr/local
  if test -d ${JDK_DIR}; then
    rm -rf ${JDK_DIR}
  fi
  /${SRC_DIR}/${JDK_FILE}
  popd
  export PATH=/usr/local/${JDK_DIR}/bin:${PATH}
  #which java
fi
export PATH=/usr/local/bin:${PATH}

if test -d mpi-build; then
  rm -rf mpi-build
fi
mkdir mpi-build
cd mpi-build

tar -xzf ${SRC_DIR}/${OPEN_MPI_VERSION}.tar.gz
cd ${OPEN_MPI_VERSION}
./configure --with-devel-headers #>configure.out 2>&1
make
make install #> make.out 2>&1

cd ..

tar -xzf ${SRC_DIR}/${MPICH_VERSION}.tar.gz ${MPICH_VERSION}/mpe
cd ${MPICH_VERSION}/mpe
./configure  --disable-f77 --with-mpicc=mpicc #> configure.out 2>&1

# These following lines fix the mpe code. The first fix is so that
# mpe will compile with openmpi. Openmpi has combined the mpio.h
# header with the regular mpi.h header, so the mpio.h include is
# no longer necessary. The second is to fix what looks like a
# leftover debug statement that prints the strings to standard
# out as well as the X-display.

mv src/log_wrap.c src/log_wrap.c.orig
sed -e '1,$s!#include "mpio.h"!//#include "mpio.h"!' src/log_wrap.c.orig > src/log_wrap.c
mv src/mpe_graphics.c src/mpe_graphics.c.orig
sed -e '962,962s!^  !//!' src/mpe_graphics.c.orig > src/mpe_graphics.c

make #>make.out 2>&1
make install

cd ../..

cd ..
